Index: drivers/filesystems/btrfs/treefuncs.c
===================================================================
--- drivers/filesystems/btrfs/treefuncs.c	(révision 74430)
+++ drivers/filesystems/btrfs/treefuncs.c	(copie de travail)
@@ -1915,9 +1866,82 @@
                     }
                 }
             }
+        } else if (bi->operation == Batch_DeleteExtentData) {
+            if (tp.item->key.obj_id < bi->key.obj_id || (tp.item->key.obj_id == bi->key.obj_id && tp.item->key.obj_type < bi->key.obj_type)) {
+                traverse_ptr tp2;
+                
+                if (find_next_item(Vcb, &tp, &tp2, FALSE, Irp)) {
+                    if (tp2.item->key.obj_id == bi->key.obj_id && tp2.item->key.obj_type == bi->key.obj_type) {
+                        tp = tp2;
+                        find_tree_end(tp.tree, &tree_end, &no_end);
+                    }
+                }
+            }
+            
+            if (tp.item->key.obj_id == bi->key.obj_id && tp.item->key.obj_type == bi->key.obj_type) {
+                BOOL ended = FALSE;
+                
+                td = tp.item;
+                
+                if (!tp.item->ignore) {
+                    tp.item->ignore = TRUE;
+                    tp.tree->header.num_items--;
+                    tp.tree->size -= tp.item->size + sizeof(leaf_node);
+                    tp.tree->write = TRUE;
+                }
+                
+                le2 = tp.item->list_entry.Flink;
+                while (le2 != &tp.tree->itemlist) {
+                    td = CONTAINING_RECORD(le2, tree_data, list_entry);
+                    
+                    if (td->key.obj_id == bi->key.obj_id && td->key.obj_type == bi->key.obj_type) {
+                        if (!td->ignore) {
+                            td->ignore = TRUE;
+                            tp.tree->header.num_items--;
+                            tp.tree->size -= td->size + sizeof(leaf_node);
+                            tp.tree->write = TRUE;
+                        }
+                    } else {
+                        ended = TRUE;
+                        break;
+                    }
+                    
+                    le2 = le2->Flink;
+                }
+                
+                while (!ended) {
+                    traverse_ptr next_tp;
+                    
+                    tp.item = td;
+                    
+                    if (!find_next_item(Vcb, &tp, &next_tp, FALSE, Irp))
+                        break;
+                    
+                    tp = next_tp;
+                    
+                    le2 = &tp.item->list_entry;
+                    while (le2 != &tp.tree->itemlist) {
+                        td = CONTAINING_RECORD(le2, tree_data, list_entry);
+                        
+                        if (td->key.obj_id == bi->key.obj_id && td->key.obj_type == bi->key.obj_type) {
+                            if (!td->ignore) {
+                                td->ignore = TRUE;
+                                tp.tree->header.num_items--;
+                                tp.tree->size -= td->size + sizeof(leaf_node);
+                                tp.tree->write = TRUE;
+                            }
+                        } else {
+                            ended = TRUE;
+                            break;
+                        }
+                        
+                        le2 = le2->Flink;
+                    }
+                }
+            }
         } else {
-            if (bi->operation == Batch_Delete || bi->operation == Batch_DeleteDirItem ||
-                bi->operation == Batch_DeleteInodeRef || bi->operation == Batch_DeleteInodeExtRef)
+            if (bi->operation == Batch_Delete || bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef ||
+                bi->operation == Batch_DeleteInodeExtRef || bi->operation == Batch_DeleteXattr)
                 td = NULL;
             else {
                 td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
@@ -1952,7 +1976,11 @@
                     }
                 }
             } else if (cmp == 0) { // item already exists
-                ignore = handle_batch_collision(Vcb, bi, tp.tree, tp.item, td, &br->items, rollback);
+                if (tp.item->ignore) {
+                    if (td)
+                        InsertHeadList(tp.item->list_entry.Blink, &td->list_entry);
+                } else
+                    ignore = handle_batch_collision(Vcb, bi, tp.tree, tp.item, td, &br->items);
             } else if (td) {
                 InsertHeadList(&tp.item->list_entry, &td->list_entry);
             }
@@ -1966,20 +1994,6 @@
                 tp.tree->size += bi->datalen + sizeof(leaf_node);
                 tp.tree->write = TRUE;
                 
-                if (rollback) {
-                    // FIXME - free this correctly
-                    tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                    if (!tp2) {
-                        ERR("out of memory\n");
-                        return;
-                    }
-                    
-                    tp2->tree = tp.tree;
-                    tp2->item = td;
-
-                    add_rollback(Vcb, rollback, ROLLBACK_INSERT_ITEM, tp2);
-                }
-                
                 listhead = &td->list_entry;
             } else {
                 listhead = &tp.item->list_entry;
@@ -1996,7 +2010,7 @@
             while (le2 != &br->items) {
                 batch_item* bi2 = CONTAINING_RECORD(le2, batch_item, list_entry);
                 
-                if (bi2->operation == Batch_DeleteInode)
+                if (bi2->operation == Batch_DeleteInode || bi2->operation == Batch_DeleteExtentData)
                     break;
                 
                 if (no_end || keycmp(bi2->key, tree_end) == -1) {
@@ -2005,8 +2019,8 @@
                     
                     ignore = FALSE;
                     
-                    if (bi2->operation == Batch_Delete || bi2->operation == Batch_DeleteDirItem ||
-                        bi2->operation == Batch_DeleteInodeRef || bi2->operation == Batch_DeleteInodeExtRef)
+                    if (bi2->operation == Batch_Delete || bi2->operation == Batch_DeleteDirItem || bi2->operation == Batch_DeleteInodeRef ||
+                        bi2->operation == Batch_DeleteInodeExtRef || bi2->operation == Batch_DeleteXattr)
                         td = NULL;
                     else {
                         td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
@@ -2026,14 +2040,10 @@
                     while (le3 != &tp.tree->itemlist) {
                         tree_data* td2 = CONTAINING_RECORD(le3, tree_data, list_entry);
                         
-                        if (!td2->ignore) {
-                            cmp = keycmp(bi2->key, td2->key);
+                        cmp = keycmp(bi2->key, td2->key);
 
-                            if (cmp == 0) {
-                                ignore = handle_batch_collision(Vcb, bi2, tp.tree, td2, td, &br->items, rollback);
-                                inserted = TRUE;
-                                break;
-                            } else if (cmp == -1) {
+                        if (cmp == 0) {
+                            if (td2->ignore) {
                                 if (td) {
                                     InsertHeadList(le3->Blink, &td->list_entry);
                                     inserted = TRUE;
@@ -2040,8 +2050,19 @@
                                 } else if (bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                                     add_delete_inode_extref(Vcb, bi2, &br->items);
                                 }
-                                break;
+                            } else
+                                ignore = handle_batch_collision(Vcb, bi2, tp.tree, td2, td, &br->items);
+
+                            inserted = TRUE;
+                            break;
+                        } else if (cmp == -1) {
+                            if (td) {
+                                InsertHeadList(le3->Blink, &td->list_entry);
+                                inserted = TRUE;
+                            } else if (bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
+                                add_delete_inode_extref(Vcb, bi2, &br->items);
                             }
+                            break;
                         }
                         
                         le3 = le3->Flink;
@@ -2055,20 +2076,6 @@
                             tp.tree->header.num_items++;
                             tp.tree->size += bi2->datalen + sizeof(leaf_node);
                             
-                            if (rollback) {
-                                // FIXME - free this correctly
-                                tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                                if (!tp2) {
-                                    ERR("out of memory\n");
-                                    return;
-                                }
-                                
-                                tp2->tree = tp.tree;
-                                tp2->item = td;
-                                
-                                add_rollback(Vcb, rollback, ROLLBACK_INSERT_ITEM, tp2);
-                            }
-                            
                             listhead = &td->list_entry;
                         }
                     } else if (!inserted && bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
@@ -2088,8 +2095,6 @@
                     t->paritem->ignore = FALSE;
                     t->parent->header.num_items++;
                     t->parent->size += sizeof(internal_node);
-                    
-                    // FIXME - do we need to add a rollback entry here?
                 }
 
                 t->header.generation = Vcb->superblock.generation;
@@ -2105,7 +2110,8 @@
         LIST_ENTRY* le = RemoveHeadList(&br->items);
         batch_item* bi = CONTAINING_RECORD(le, batch_item, list_entry);
         
-        if ((bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef || bi->operation == Batch_DeleteInodeExtRef) && bi->data)
+        if ((bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef ||
+            bi->operation == Batch_DeleteInodeExtRef || bi->operation == Batch_DeleteXattr) && bi->data)
             ExFreePool(bi->data);
         
         ExFreeToPagedLookasideList(&Vcb->batch_item_lookaside, bi);
@@ -2112,12 +2118,12 @@
     }
 }
 
-void commit_batch_list(device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
+void commit_batch_list(device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp) {
     while (!IsListEmpty(batchlist)) {
         LIST_ENTRY* le = RemoveHeadList(batchlist);
         batch_root* br2 = CONTAINING_RECORD(le, batch_root, list_entry);
         
-        commit_batch_list_root(Vcb, br2, Irp, rollback);
+        commit_batch_list_root(Vcb, br2, Irp);
         
         ExFreePool(br2);
     }
